# -------------------------------------------------------------------------
# ANZX
# -------------------------------------------------------------------------

sub access_check {
	&get_host;
	local($flag)=0;
	foreach (@set_data10) {
		if (!$_) { next; }
		$_ =~ s/\*/\.\*/g;
		if ($host =~ /$_/i) { $flag=1; last; }
	}
	if ($flag) { &xml_error("3","Failed to authorize."); }
	&recieve_xmlrpc;
}

# -------------------------------------------------------------------------
#  XMLMmethodName
# -------------------------------------------------------------------------

sub recieve_xmlrpc {
	if ($ENV{'REQUEST_METHOD'} eq "POST") {
		read (STDIN, $xmldata, $ENV{'CONTENT_LENGTH'});
	} else {
		$xmldata = $ENV{'QUERY_STRING'};
	}
	$methodName = $1 if ($xmldata =~ /<methodName>(.*?)<\/methodName>/is);
	if ($methodName eq "blogger.newPost") { &blogger_newPost; }
	elsif ($methodName eq "blogger.editPost") { &blogger_editPost; }
	elsif ($methodName eq "blogger.deletePost") { &blogger_deletePost; }
	elsif ($methodName eq "blogger.getPost") { &blogger_getPost; }
	elsif ($methodName eq "blogger.getRecentPosts") { &blogger_getRecentPosts; }
	elsif ($methodName eq "blogger.getUsersBlogs") { &blogger_getUsersBlogs; }
	elsif ($methodName eq "blogger.getUserInfo") { &blogger_getUserInfo; }
	elsif ($methodName eq "metaWeblog.newPost") { &metaWeblog_newPost; }
	elsif ($methodName eq "metaWeblog.editPost") { &metaWeblog_editPost; }
	elsif ($methodName eq "metaWeblog.getPost") { &metaWeblog_getPost; }
	elsif ($methodName eq "metaWeblog.getRecentPosts") { &metaWeblog_getRecentPosts; }
	elsif ($methodName eq "metaWeblog.newMediaObject") { &metaWeblog_newMediaObject; }
	elsif ($methodName eq "mt.getCategoryList") { &mt_getCategoryList; }
	elsif ($methodName eq "mt.getPostCategories") { &mt_getPostCategories; }
	elsif ($methodName eq "mt.setPostCategories") { &mt_setPostCategories; }
	elsif ($methodName eq "mt.supportedMethods") { &mt_supportedMethods; }
	else { &xml_error("1","Unknown method."); }
}

# -------------------------------------------------------------------------
#  blogger.newPost
# -------------------------------------------------------------------------

sub blogger_newPost {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@string = ($params =~ /<string>(.*?)<\/string>/gs);
	$in{'id'} = $string[2];
	$in{'pass'} = $string[3];
	$in{'title'} = "";
	$in{'comment'} = $string[4];
	$in{'copy'} = $1 if ($params =~ /<boolean>(.*?)<\/boolean>/is);
	&$jcnv(\$in{'title'}, "sjis");
	&$jcnv(\$in{'comment'}, "sjis");
	$in{'comment'} =~ s/\r\n/<br \/>/g;
	$in{'comment'} =~ s/\r/<br \/>/g;
	$in{'comment'} =~ s/\n/<br \/>/g;
	$in{'comment'} =~ s/&lt;/</g;
	$in{'comment'} =~ s/&gt;/>/g;
	$in{'comment'} =~ s/&amp;/&/g;
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&newPost;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&newPost;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  blogger.editPost
# -------------------------------------------------------------------------

sub blogger_editPost {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@string = ($params =~ /<string>(.*?)<\/string>/gs);
	$in{'num'} = $string[1];
	$in{'id'} = $string[2];
	$in{'pass'} = $string[3];
	$in{'comment'} = $string[4];
	$in{'copy'} = $1 if ($params =~ /<boolean>(.*?)<\/boolean>/is);
	if ($in{'copy'} eq "1") { $in{'copy'} = ""; }
	else { $in{'copy'} = "1"; }
	&$jcnv(\$in{'comment'}, "sjis");
	$in{'comment'} =~ s/\r\n/<br \/>/g;
	$in{'comment'} =~ s/\r/<br \/>/g;
	$in{'comment'} =~ s/\n/<br \/>/g;
	$in{'comment'} =~ s/&lt;/</g;
	$in{'comment'} =~ s/&gt;/>/g;
	$in{'comment'} =~ s/&amp;/&/g;
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&editPost;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&editPost;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  blogger.deletePost 
# -------------------------------------------------------------------------

sub blogger_deletePost {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@string = ($params =~ /<string>(.*?)<\/string>/gs);
	$in{'no'} = $string[1];
	$in{'id'} = $string[2];
	$in{'pass'} = $string[3];
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&deletePost;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&deletePost;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  blogger.getPost 
# -------------------------------------------------------------------------

sub blogger_getPost {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@string = ($params =~ /<string>(.*?)<\/string>/gs);
	$in{'no'} = $string[1];
	$in{'id'} = $string[2];
	$in{'pass'} = $string[3];
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&getPost;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&getPost;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  blogger.getRecentPosts 
# -------------------------------------------------------------------------

sub blogger_getRecentPosts {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@string = ($params =~ /<string>(.*?)<\/string>/gs);
	$in{'id'} = $string[2];
	$in{'pass'} = $string[3];
	$in{'num'} = $2 if ($params =~ /<i(.*?)>(.*?)<\/i(.*?)>/is);
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&getRecentPosts;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&getRecentPosts;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  blogger.getUsersBlogs 
# -------------------------------------------------------------------------

sub blogger_getUsersBlogs {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@string = ($params =~ /<string>(.*?)<\/string>/gs);
	$in{'id'} = $string[1];
	$in{'pass'} = $string[2];
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&getUsersBlogs;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&getUsersBlogs;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  blogger.getUserInfo 
# -------------------------------------------------------------------------

sub blogger_getUserInfo {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@string = ($params =~ /<string>(.*?)<\/string>/gs);
	$in{'id'} = $string[1];
	$in{'pass'} = $string[2];
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&getUserInfo;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&getUserInfo;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  metaWeblog.newPost
# -------------------------------------------------------------------------

sub metaWeblog_newPost {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@param = ($params =~ /<param>(.*?)<\/param>/gs);
	$in{'id'} = $1 if ($param[1] =~ /<string>(.*?)<\/string>/is);
	$in{'pass'} = $1 if ($param[2] =~ /<string>(.*?)<\/string>/is);
	$struct = $1 if ($param[3] =~ /<struct>(.*?)<\/struct>/is);
	@struct_member = ($struct =~ /<member>(.*?)<\/member>/gs);
	$i = 0;
	while ($i < @struct_member) {
		$struct_name[$i] = $1 if ($struct_member[$i] =~ /<name>(.*?)<\/name>/is);
		if ($struct_name[$i] eq "title") {
			$in{'title'} = $1 if ($struct_member[$i] =~ /<string>(.*?)<\/string>/is);
			$in{'title'} = &mime_dec_base64( $1 ) if ($struct_member[$i] =~ /<base64>(.*?)<\/base64>/is);
		}
		if ($struct_name[$i] eq "description") {
			$in{'comment'} = $1 if ($struct_member[$i] =~ /<string>(.*?)<\/string>/is);
			$in{'comment'} = &mime_dec_base64( $1 ) if ($struct_member[$i] =~ /<base64>(.*?)<\/base64>/is);
		}
		$i++;
	}
	$in{'uc_res'} = $set_data1[21];
	$in{'tb_res'} = $set_data1[22];
	$in{'copy'} = $1 if ($param[4] =~ /<boolean>(.*?)<\/boolean>/is);
	$in{'copy'} = $2 if ($param[4] =~ /<i(.*?)>(.*?)<\/i(.*?)>/is);
	&$jcnv(\$in{'title'}, "sjis");
	&$jcnv(\$in{'comment'}, "sjis");
	$in{'comment'} =~ s/\r\n/<br \/>/g;
	$in{'comment'} =~ s/\r/<br \/>/g;
	$in{'comment'} =~ s/\n/<br \/>/g;
	$in{'comment'} =~ s/&lt;/</g;
	$in{'comment'} =~ s/&gt;/>/g;
	$in{'comment'} =~ s/&amp;/&/g;
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&newPost;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&newPost;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  metaWeblog.editPost
# -------------------------------------------------------------------------

sub metaWeblog_editPost {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@param = ($params =~ /<param>(.*?)<\/param>/gs);
	$in{'num'} = $1 if ($param[0] =~ /<string>(.*?)<\/string>/is);
	$in{'id'} = $1 if ($param[1] =~ /<string>(.*?)<\/string>/is);
	$in{'pass'} = $1 if ($param[2] =~ /<string>(.*?)<\/string>/is);
	$struct = $1 if ($param[3] =~ /<struct>(.*?)<\/struct>/is);
	@struct_member = ($struct =~ /<member>(.*?)<\/member>/gs);
	$i = 0;
	while ($i < @struct_member) {
		$struct_name[$i] = $1 if ($struct_member[$i] =~ /<name>(.*?)<\/name>/is);
		if ($struct_name[$i] eq "title") {
			$in{'title'} = $1 if ($struct_member[$i] =~ /<string>(.*?)<\/string>/is);
			$in{'title'} = &mime_dec_base64( $1 ) if ($struct_member[$i] =~ /<base64>(.*?)<\/base64>/is);
		}
		if ($struct_name[$i] eq "description") {
			$in{'comment'} = $1 if ($struct_member[$i] =~ /<string>(.*?)<\/string>/is);
			$in{'comment'} = &mime_dec_base64( $1 ) if ($struct_member[$i] =~ /<base64>(.*?)<\/base64>/is);
		}
		$i++;
	}
	$in{'copy'} = $1 if ($param[4] =~ /<boolean>(.*?)<\/boolean>/is);
	$in{'copy'} = $2 if ($param[4] =~ /<i(.*?)>(.*?)<\/i(.*?)>/is);
	&$jcnv(\$in{'title'}, "sjis");
	&$jcnv(\$in{'comment'}, "sjis");
	$in{'comment'} =~ s/\r\n/<br \/>/g;
	$in{'comment'} =~ s/\r/<br \/>/g;
	$in{'comment'} =~ s/\n/<br \/>/g;
	$in{'comment'} =~ s/&lt;/</g;
	$in{'comment'} =~ s/&gt;/>/g;
	$in{'comment'} =~ s/&amp;/&/g;
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&editPost;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&editPost;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  metaWeblog.getPost 
# -------------------------------------------------------------------------

sub metaWeblog_getPost {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@string = ($params =~ /<string>(.*?)<\/string>/gs);
	$in{'no'} = $string[0];
	$in{'id'} = $string[1];
	$in{'pass'} = $string[2];
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&getPost;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&getPost;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  metaWeblog.getRecentPosts 
# -------------------------------------------------------------------------

sub metaWeblog_getRecentPosts {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@string = ($params =~ /<string>(.*?)<\/string>/gs);
	$in{'id'} = $string[1];
	$in{'pass'} = $string[2];
	$in{'num'} = $2 if ($params =~ /<i(.*?)>(.*?)<\/i(.*?)>/is);
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&getRecentPosts;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&getRecentPosts;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  metaWeblog.newMediaObject
# -------------------------------------------------------------------------

sub metaWeblog_newMediaObject {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@param = ($params =~ /<param>(.*?)<\/param>/gs);
	$in{'id'} = $1 if ($param[1] =~ /<string>(.*?)<\/string>/is);
	$in{'pass'} = $1 if ($param[2] =~ /<string>(.*?)<\/string>/is);
	$struct = $1 if ($param[3] =~ /<struct>(.*?)<\/struct>/is);
	@struct_member = ($struct =~ /<member>(.*?)<\/member>/gs);
	$i = 0;
	while ($i < @struct_member) {
		$bits = $1 if ($struct_member[$i] =~ /<base64>(.*?)<\/base64>/is);
		$struct_name[$i] = $1 if ($struct_member[$i] =~ /<name>(.*?)<\/name>/is);
		$struct_string[$i] = $1 if ($struct_member[$i] =~ /<string>(.*?)<\/string>/is);
		if ($struct_name[$i] eq "name") {
			$fname = $struct_string[$i];
		}
		if ($struct_name[$i] eq "type") {
			$type = $struct_string[$i];
		}
		$i++;
	}
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&newMediaObject;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&newMediaObject;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  mt.getCategoryList 
# -------------------------------------------------------------------------

sub mt_getCategoryList {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@string = ($params =~ /<string>(.*?)<\/string>/gs);
	$in{'id'} = $string[1];
	$in{'pass'} = $string[2];
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&getCategoryList;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&getCategoryList;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  mt.getPostCategories 
# -------------------------------------------------------------------------

sub mt_getPostCategories {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@string = ($params =~ /<string>(.*?)<\/string>/gs);
	$in{'no'} = $string[0];
	$in{'id'} = $string[1];
	$in{'pass'} = $string[2];
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&getPostCategories;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&getPostCategories;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  mt.setPostCategories
# -------------------------------------------------------------------------

sub mt_setPostCategories {
	$params = $1 if ($xmldata =~ /<params>(.*?)<\/params>/is);
	@string = ($params =~ /<string>(.*?)<\/string>/gs);
	$in{'num'} = $string[0];
	$in{'id'} = $string[1];
	$in{'pass'} = $string[2];
	@struct = ($params =~ /<struct>(.*?)<\/struct>/gs);
	$i = 0;
	$flag = 0;
	while ($i < @struct) {
		@struct_member = ($struct[$i] =~ /<member>(.*?)<\/member>/gs);
		$j = 0;
		while ($j < @struct_member) {
			$struct_name[$j] = $1 if ($struct_member[$j] =~ /<name>(.*?)<\/name>/is);
			$struct_string[$j] = $1 if ($struct_member[$j] =~ /<string>(.*?)<\/string>/is);
			$struct_boolean[$j] = $1 if ($struct_member[$j] =~ /<boolean>(.*?)<\/boolean>/is);
			if ($struct_name[$j] eq "categoryId") {
				$in{'category'} = $struct_string[$j];
			}
			if ($struct_name[$j] eq "isPrimary" && $struct_boolean[$j] == 1) {
				$flag = 1;
			}
			$j++;
		}
		if ($flag == 1) {last;}
		$i++;
	}
	if ($in{'id'} eq "admin") {
		$idno = 99;
		&user_check_xmlrpc;
		&setPostCategories;
	} elsif ($in{'id'} ne "") {
		$idno = 0;
		$n = @entry_data1;
		while ($idno < $n) {
			if ($in{'id'} eq "$entry_data1[$idno]") {
				&user_check_xmlrpc;
				&setPostCategories;
			}
			$idno++;
		}
		&xml_error("3","Failed to authorize.");
	}
}

# -------------------------------------------------------------------------
#  mt.supportedMethods
# -------------------------------------------------------------------------

sub mt_supportedMethods {
	print 'Content-Type: text/xml;',"\n\n";
	print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
	print '<methodResponse>',"\n";
	print '<params>',"\n";
	print '<param>',"\n";
	print '<value>',"\n";
	print '<array>',"\n";
	print '<data>',"\n";
	print '<value><string>blogger.newPost</string></value>',"\n";
	print '<value><string>blogger.editPost</string></value>',"\n";
	print '<value><string>blogger.deletePost</string></value>',"\n";
	print '<value><string>blogger.getPost</string></value>',"\n";
	print '<value><string>blogger.getRecentPosts</string></value>',"\n";
	print '<value><string>blogger.getUsersBlogs</string></value>',"\n";
	print '<value><string>blogger.getUserInfo</string></value>',"\n";
	print '<value><string>metaWeblog.newPost</string></value>',"\n";
	print '<value><string>metaWeblog.editPost</string></value>',"\n";
	print '<value><string>metaWeblog.getPost</string></value>',"\n";
	print '<value><string>metaWeblog.getRecentPosts</string></value>',"\n";
	print '<value><string>metaWeblog.newMediaObject</string></value>',"\n";
	print '<value><string>mt.getCategoryList</string></value>',"\n";
	print '<value><string>mt.getPostCategories</string></value>',"\n";
	print '<value><string>mt.setPostCategories</string></value>',"\n";
	print '</data>',"\n";
	print '</array>',"\n";
	print '</value>',"\n";
	print '</param>',"\n";
	print '</params>',"\n";
	print '</methodResponse>',"\n";
	exit;
}

# -------------------------------------------------------------------------
#  [Uƍ
# -------------------------------------------------------------------------

sub user_check_xmlrpc {
	if ($idno == 99) {
		$match = &decrypt("$in{'pass'}","$set_data3[0]");
		if ($match ne 'yes') { &xml_error("3","Failed to authorize."); }
	} else {
		$match = &decrypt("$in{'pass'}","$entry_data2[$idno]");
		if ($match ne 'yes') { &xml_error("3","Failed to authorize."); }
	}
}

# -------------------------------------------------------------------------
#  Gg[̐VK쐬
# -------------------------------------------------------------------------

sub newPost {
	if ($idno != 99) {
		$entry_name = $idno;
		$entry_url = $entry_data4[$idno];
		$entry_mail = $entry_data5[$idno];
	} else {
		$entry_name = $idno;
		$entry_url = $set_data1[3];
		$entry_mail = $set_data1[11];
	}

	&get_time;
	&get_host;
	if ($set_data1[9]) { &lock; }
	open(IN,"$set_data1[6]") || &xml_error("2","Failed to open a file.");
	@lines = <IN>;
	close(IN);
	$entry_no = 0;
	$top = shift(@lines);
	($no,$ip,$time2) = split(/<>/, $top);
	$no++;
	$new_no = $no;
	use Time::Local;
	if ($idno != 99 && $entry_data9[$idno] eq "0") { $in{'copy'} = "1"; }
	elsif ($in{'copy'} eq "1") { $in{'copy'} = ""; }
	else { $in{'copy'} = "1"; }
	$flag=0;
	foreach (@lines) {
		($no2,$exno2,$reno2,$ca,$y,$mo,$d,$wd,$tim,$n,$tit,$co,$u,
			$ma,$ho,$p,$tail2,$w,$h,$ws2,$hs2,$s,$a,$cp) = split(/<>/);
		($d_hour,$d_min) = split(/&/,$tim);
		$t1 = timelocal(0, $min, $hour, $mday, $mon-1, $year-1900);
		$t2 = timelocal(0, $d_min, $d_hour, $d, $mo-1, $y-1900);
		if ($t1 >= $t2 && $flag == 0 && $exno2 eq "") {
			push(@new,"$no<><>0&0&$in{'uc_res'}&$in{'tb_res'}<><>$year<>$mon<>$mday<>$wday<>$time<>$entry_name<>$in{'title'}<>$in{'comment'}<>$entry_url<>$entry_mail<>$host<>$set_data3[0]<>$tail<>$W<>$H<>$wss<>$hss<>$set_data9[5]<><>$in{'copy'}<>\n");
			$flag=1;
		}
		push(@new,$_);
	}
	if ($flag == 0) {
		push(@new,"$no<><>0&0&$in{'uc_res'}&$in{'tb_res'}<><>$year<>$mon<>$mday<>$wday<>$time<>$entry_name<>$in{'title'}<>$in{'comment'}<>$entry_url<>$entry_mail<>$host<>$set_data3[0]<>$tail<>$W<>$H<>$wss<>$hss<>$set_data9[5]<><>$in{'copy'}<>\n");
	}
	unshift(@new,"$no<>$addr<>$times<>\n");
	open(OUT,">$set_data1[6]") || &xml_error("4","Failed to write a file.");
	print OUT @new;
	close(OUT);
	if (!$copy) {&list_plus;}
	$entry_copy = $copy;
	if ($set_data1[9]) { &unlock; }
	if (!$entry_copy) {
		$rb_no = 5;
		&user_rebuild;
	}
	&xml_reply("$new_no");
}

# -------------------------------------------------------------------------
#  Gg[̍폜
# -------------------------------------------------------------------------

sub deletePost {
	if ($set_data1[9]) { &lock; }
	$a_save = 0;
	open(IN,"$set_data1[6]") || &xml_error("2","Failed to open a file.");
	$top = <IN>;
	while (<IN>) {
		$flag=0;
		($no,$exno,$reno,$category,$year,$mon,$mday,$wday,$time,$name,$title,$comment,$url,
			$mail,$host,$pw,$tail,$w,$h,$ws,$hs,$skin,$album,$copy) = split(/<>/);
		if ($in{'no'} eq "$no") {
			if (-e "$set_data1[4]files/$no$tail") { unlink("$set_data1[4]files/$no$tail"); }
			if (-e "$set_data1[4]files/$no\_s$tail") { unlink("$set_data1[4]files/$no\_s$tail"); }
			if (-e "$set_data1[4]files/$no.$set_data2[32]") { unlink("$set_data1[4]files/$no.$set_data2[32]"); }
			if (-e "$set_data1[4]album_$year\_$mon\_$mday\_$no.$set_data2[32]") { unlink("$set_data1[4]album_$year\_$mon\_$mday\_$no.$set_data2[32]"); }
			$del_html = "$year\_$mon\_$mday\_$no.$set_data2[32]";
			if (-e "$set_data1[4]$del_html") { unlink("$set_data1[4]$del_html"); }
			if (!$copy) {&list_minus;}
			$entry_copy = $copy;
			$flag=1;
			$a_save = 1;
			next;
		} elsif ($in{'no'} eq "$exno") {
			if (-e "$set_data1[4]files/$no$tail") { unlink("$set_data1[4]files/$no$tail"); }
			if (-e "$set_data1[4]files/$no\_s$tail") { unlink("$set_data1[4]files/$no\_s$tail"); }
			if (-e "$set_data1[4]files/$no.$set_data2[32]") { unlink("$set_data1[4]files/$no.$set_data2[32]"); }
			$flag=1;
			next;
		}
		if ($flag == 0) { push(@new,$_); }
	}
	close(IN);
	unshift(@new,$top);
	open(OUT,">$set_data1[6]") || &xml_error("4","Failed to write a file.");
	print OUT @new;
	close(OUT);
	if ($set_data1[9]) { &unlock; }
	if($a_save == 1){
		if ($set_data1[9]) { &lock; }
		@new=();
		open(IN,"$set_data1[7]") || &xml_error("2","Failed to open a file.");
		$top = <IN>;
		while (<IN>) {
			$flag=0;
			($no,$exno,$reno,$category,$year,$mon,$mday,$wday,$time,$name,$title,$comment,$url,
				$mail,$host,$pw,$tail,$w,$h,$ws,$hs,$skin,$album,$copy) = split(/<>/);
			if ($in{'no'} eq "$reno") {
				$flag=1;
				next;
			}
			if ($flag == 0) { push(@new,$_); }
		}
		close(IN);
		unshift(@new,$top);
		open(OUT,">$set_data1[7]") || &xml_error("4","Failed to write a file.");
		print OUT @new;
		close(OUT);
		if ($set_data1[9]) { &unlock; }
	}
	if (!$entry_copy) {
		$rb_no = 5;
		&user_rebuild;
	}
	print 'Content-Type: text/xml;',"\n\n";
	print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
	print '<methodResponse>',"\n";
	print '<params>',"\n";
	print '<param>',"\n";
	print '<value><boolean>1</boolean></value>',"\n";
	print '</param>',"\n";
	print '</params>',"\n";
	print '</methodResponse>',"\n";
	exit;
}

# -------------------------------------------------------------------------
#  Gg[̕ҏW
# -------------------------------------------------------------------------

sub editPost {
	if ($set_data1[9]) { &lock; }
	open(IN,"$set_data1[6]") || &xml_error("2","Failed to open a file.");
	$top = <IN>;
	while (<IN>) {
		($no,$exno,$reno,$category,$year,$mon,$mday,$wday,$time,$name,$title,$comment,$url,
			$mail,$host,$pw,$tail2,$w2,$h2,$ws2,$hs2,$skin,$album,$copy) = split(/<>/);
		if ($in{'num'} == $no) {
			if ($idno != 99 && $entry_data9[$idno] eq "0") { $in{'copy'} = $copy; }
			elsif ($in{'copy'} eq "1") { $in{'copy'} = ""; }
			else { $in{'copy'} = "1"; }
			if ($methodName eq "blogger.editPost") {
				$_ = "$no<><>$reno<>$category<>$year<>$mon<>$mday<>$wday<>$time<>$name<>$title<>$in{'comment'}<>$url<>$mail<>$host<>$set_data3[0]<>$tail<>$w<>$h<>$ws<>$hs<>$skin<>$album<>$in{'copy'}<>\n";
			} else {
				if ($in{'title'}) { $title = $in{'title'};}
				if ($in{'comment'}) { $comment = $in{'comment'};}
				$_ = "$no<><>$reno<>$category<>$year<>$mon<>$mday<>$wday<>$time<>$name<>$title<>$comment<>$url<>$mail<>$host<>$set_data3[0]<>$tail<>$w<>$h<>$ws<>$hs<>$skin<>$album<>$in{'copy'}<>\n";
			}
			if (!$copy && !$in{'copy'}) {
				$entry_copy = "";
			} elsif (!$copy && $in{'copy'}) {
				$del_html = "$year\_$mon\_$mday\_$no.$set_data2[32]";
				if (-e "$set_data1[4]$del_html") { unlink("$set_data1[4]$del_html"); }
				if (-e "$set_data1[4]album_$year\_$mon\_$mday\_$no.$set_data2[32]") { unlink("$set_data1[4]album_$year\_$mon\_$mday\_$no.$set_data2[32]"); }
				&list_minus;
				$entry_copy = "";
			} elsif ($copy && !$in{'copy'}) {
				&list_plus;
				$entry_copy = "";
			} else {
				$entry_copy = 1;
			}
		}
		push(@new,$_);
	}
	close(IN);
	unshift(@new,$top);
	open(OUT,">$set_data1[6]") || &xml_error("4","Failed to write a file.");
	print OUT @new;
	close(OUT);
	if ($set_data1[9]) { &unlock; }
	if (!$entry_copy) {
		$rb_no = 5;
		&user_rebuild;
	}
	print 'Content-Type: text/xml;',"\n\n";
	print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
	print '<methodResponse>',"\n";
	print '<params>',"\n";
	print '<param>',"\n";
	print '<value><boolean>1</boolean></value>',"\n";
	print '</param>',"\n";
	print '</params>',"\n";
	print '</methodResponse>',"\n";
	exit;
}

# -------------------------------------------------------------------------
#  IDL擾
# -------------------------------------------------------------------------

sub getPost {
	open(IN,"$set_data1[6]") || &error("Open Error : $set_data1[6]");
	$top = <IN>;
	while (<IN>) {
		($no2,$exno2,$reno2,$ca,$y,$mo,$d,$wd,$tim,$n,$tit,$co,$u,
			$ma,$ho,$p,$tail2,$w2,$h2,$ws2,$hs2,$s,$a,$cp) = split(/<>/);
		if ($in{'no'} eq "$no2") { 
			&$jcnv(\$tit, "utf8");
			$co =~ s/<br \/>/\n/g;
			$co =~ s/</&lt;/g;
			&$jcnv(\$co, "utf8");
			$stringlink = "$set_data1[5]$y\_$mo\_$d\_$no2.$set_data2[32]";
			($d_hour,$d_min) = split(/&/,$tim);
			$mo = sprintf("%02d", $mo);
			$d = sprintf("%02d", $d);
			$stringdate = "$y$mo$d\T$d_hour:$d_min:00";
			print 'Content-Type: text/xml;',"\n\n";
			print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
			print '<methodResponse>',"\n";
			print '<params>',"\n";
			print '<param>',"\n";
			print '<value>',"\n";
			print '<struct>',"\n";
			print '<member><name>postid</name><value><string>',$no2,'</string></value></member>',"\n";
			print '<member><name>userid</name><value><string>',$n,'</string></value></member>',"\n";
				if ($methodName eq "blogger.getPost") {
					print '<member><name>content</name><value><string>',$co,'</string></value></member>',"\n";
				} else {
					print '<member><name>title</name><value><string>',$tit,'</string></value></member>',"\n";
					print '<member><name>description</name><value><string>',$co,'</string></value></member>',"\n";
					print '<member><name>link</name><value><string>',$stringlink,'</string></value></member>',"\n";
					print '<member><name>permaLink</name><value><string>',$stringlink,'</string></value></member>',"\n";
				}
			print '<member><name>dateCreated</name><value><dateTime.iso8601>',$stringdate,'</dateTime.iso8601></value></member>',"\n";
			print '</struct>',"\n";
			print '</value>',"\n";
			print '</param>',"\n";
			print '</params>',"\n";
			print '</methodResponse>',"\n";
			last;
		}
	}
	close(IN);
	exit;
}

# -------------------------------------------------------------------------
#  ŐV̋L擾
# -------------------------------------------------------------------------

sub getRecentPosts {
	print 'Content-Type: text/xml;',"\n\n";
	print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
	print '<methodResponse>',"\n";
	print '<params>',"\n";
	print '<param>',"\n";
	print '<value>',"\n";
	print '<array>',"\n";
	print '<data>',"\n";
	open(IN,"$set_data1[6]") || &error("Open Error : $set_data1[6]");
	$top = <IN>;
	$e = 0;
	while (<IN>) {
		($no2,$exno2,$reno2,$ca,$y,$mo,$d,$wd,$tim,$n,$tit,$co,$u,
			$ma,$ho,$p,$tail2,$w2,$h2,$ws2,$hs2,$s,$a,$cp) = split(/<>/);
		if ($idno == 99 || $entry_data9[$idno] == 2) {
			if ($exno2 eq "" && $e < $in{'num'}) { 
				&$jcnv(\$tit, "utf8");
				$co =~ s/<br \/>/\n/g;
				$co =~ s/</&lt;/g;
				&$jcnv(\$co, "utf8");
				$stringlink = "$set_data1[5]$y\_$mo\_$d\_$no2.$set_data2[32]";
				($d_hour,$d_min) = split(/&/,$tim);
				$mo = sprintf("%02d", $mo);
				$d = sprintf("%02d", $d);
				$stringdate = "$y$mo$d\T$d_hour:$d_min:00";
				print '<value>',"\n";
				print '<struct>',"\n";
				print '<member><name>postid</name><value><string>',$no2,'</string></value></member>',"\n";
				print '<member><name>userid</name><value><string>',$n,'</string></value></member>',"\n";
				if ($methodName eq "blogger.getRecentPosts") {
					print '<member><name>content</name><value><string>',$co,'</string></value></member>',"\n";
				} else {
					print '<member><name>title</name><value><string>',$tit,'</string></value></member>',"\n";
					print '<member><name>description</name><value><string>',$co,'</string></value></member>',"\n";
					print '<member><name>link</name><value><string>',$stringlink,'</string></value></member>',"\n";
					print '<member><name>permaLink</name><value><string>',$stringlink,'</string></value></member>',"\n";
				}
				print '<member><name>dateCreated</name><value><dateTime.iso8601>',$stringdate,'</dateTime.iso8601></value></member>',"\n";
				print '</struct>',"\n";
				print '</value>',"\n";
				$e++;
				next;
			}
		} else {
			if ($exno2 eq "" && $e < $in{'num'} && $n eq $idno) { 
				&$jcnv(\$tit, "utf8");
				$co =~ s/<br \/>/\n/g;
				$co =~ s/</&lt;/g;
				&$jcnv(\$co, "utf8");
				$stringlink = "$set_data1[5]$y\_$mo\_$d\_$no2.$set_data2[32]";
				($d_hour,$d_min) = split(/&/,$tim);
				$mo = sprintf("%02d", $mo);
				$d = sprintf("%02d", $d);
				$stringdate = "$y$mo$d\T$d_hour:$d_min:00";
				print '<value>',"\n";
				print '<struct>',"\n";
				print '<member><name>postid</name><value><string>',$no2,'</string></value></member>',"\n";
				print '<member><name>userid</name><value><string>',$n,'</string></value></member>',"\n";
				if ($methodName eq "blogger.getRecentPosts") {
					print '<member><name>content</name><value><string>',$co,'</string></value></member>',"\n";
				} else {
					print '<member><name>title</name><value><string>',$tit,'</string></value></member>',"\n";
					print '<member><name>description</name><value><string>',$co,'</string></value></member>',"\n";
					print '<member><name>link</name><value><string>',$stringlink,'</string></value></member>',"\n";
					print '<member><name>permaLink</name><value><string>',$stringlink,'</string></value></member>',"\n";
				}
				print '<member><name>dateCreated</name><value><dateTime.iso8601>',$stringdate,'</dateTime.iso8601></value></member>',"\n";
				print '</struct>',"\n";
				print '</value>',"\n";
				$e++;
				next;
			}
		}
	}
	close(IN);
	print '</data>',"\n";
	print '</array>',"\n";
	print '</value>',"\n";
	print '</param>',"\n";
	print '</params>',"\n";
	print '</methodResponse>',"\n";
	exit;
}

# -------------------------------------------------------------------------
#  webloǧQ
# -------------------------------------------------------------------------

sub getUsersBlogs {
	$url = "$set_data1[3]index.$set_data2[32]";
	$blogname = $set_data1[1];
	&$jcnv(\$blogname, "utf8");

	print 'Content-Type: text/xml;',"\n\n";
	print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
	print '<methodResponse>',"\n";
	print '<params>',"\n";
	print '<param>',"\n";
	print '<value>',"\n";
	print '<array>',"\n";
	print '<data>',"\n";
	print '<value>',"\n";
	print '<struct>',"\n";
	print '<member><name>url</name><value><string>',$url,'</string></value></member>',"\n";
	print '<member><name>blogid</name><value><string>0</string></value></member>',"\n";
	print '<member><name>blogName</name><value><string>',$blogname,'</string></value></member>',"\n";
	print '</struct>',"\n";
	print '</value>',"\n";
	print '</data>',"\n";
	print '</array>',"\n";
	print '</value>',"\n";
	print '</param>',"\n";
	print '</params>',"\n";
	print '</methodResponse>',"\n";
	exit;
}

# -------------------------------------------------------------------------
#  User
# -------------------------------------------------------------------------

sub getUserInfo {
	$url = "$set_data1[3]index.$set_data2[32]";

	print 'Content-Type: text/xml;',"\n\n";
	print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
	print '<methodResponse>',"\n";
	print '<params>',"\n";
	print '<param>',"\n";
	print '<value>',"\n";
	print '<struct>',"\n";
	print '<member><name>userid</name><value><string>',$idno,'</string></value></member>',"\n";
	if ($idno == 99) {
		$nickname = $set_data1[0];
		&$jcnv(\$nickname, "utf8");
		print '<member><name>firstname</name><value><string></string></value></member>',"\n";
		print '<member><name>lastname</name><value><string></string></value></member>',"\n";
		print '<member><name>nickname</name><value><string>',$nickname,'</string></value></member>',"\n";
		print '<member><name>email</name><value><string>',$set_data1[11],'</string></value></member>',"\n";
		print '<member><name>url</name><value><string>',$set_data1[3],'</string></value></member>',"\n";
	} else {
		$nickname = $entry_data3[$idno];
		&$jcnv(\$nickname, "utf8");
		print '<member><name>firstname</name><value><string></string></value></member>',"\n";
		print '<member><name>lastname</name><value><string></string></value></member>',"\n";
		print '<member><name>nickname</name><value><string>',$nickname,'</string></value></member>',"\n";
		print '<member><name>email</name><value><string>',$entry_data5[$idno],'</string></value></member>',"\n";
		print '<member><name>url</name><value><string>',$entry_data4[$idno],'</string></value></member>',"\n";
	}
	print '</struct>',"\n";
	print '</value>',"\n";
	print '</param>',"\n";
	print '</params>',"\n";
	print '</methodResponse>',"\n";
	exit;
}

# -------------------------------------------------------------------------
#  JeS擾
# -------------------------------------------------------------------------

sub getCategoryList {
	print 'Content-Type: text/xml;',"\n\n";
	print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
	print '<methodResponse>',"\n";
	print '<params>',"\n";
	print '<param>',"\n";
	print '<value>',"\n";
	print '<array>',"\n";
	print '<data>',"\n";
	$i = 0;
	while ($i < @set_data5) {
		if ($set_data5[$i]){
			$category_name = $set_data6[$i];
			&$jcnv(\$category_name, "utf8");
			print '<value>',"\n";
			print '<struct>',"\n";
			print '<member><name>categoryId</name><value><string>',$i,'</string></value></member>',"\n";
			print '<member><name>categoryName</name><value><string>',$category_name,'</string></value></member>',"\n";
			print '</struct>',"\n";
			print '</value>',"\n";
		}
		$i++;
	}
	print '</data>',"\n";
	print '</array>',"\n";
	print '</value>',"\n";
	print '</param>',"\n";
	print '</params>',"\n";
	print '</methodResponse>',"\n";
	exit;

}
# -------------------------------------------------------------------------
#  IDJeS擾
# -------------------------------------------------------------------------

sub getPostCategories {
	open(IN,"$set_data1[6]") || &error("Open Error : $set_data1[6]");
	$top = <IN>;
	while (<IN>) {
		($no2,$exno2,$reno2,$ca,$y,$mo,$d,$wd,$tim,$n,$tit,$co,$u,
			$ma,$ho,$p,$tail2,$w2,$h2,$ws2,$hs2,$s,$a,$cp) = split(/<>/);
		if ($in{'no'} eq "$no2") { 
			if ($ca ne "") {
				$category_name = $set_data6[$ca];
				&$jcnv(\$category_name, "utf8");
			} else {
				$category_name = "";
			}
			print 'Content-Type: text/xml;',"\n\n";
			print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
			print '<methodResponse>',"\n";
			print '<params>',"\n";
			print '<param>',"\n";
			print '<value>',"\n";
			print '<array>',"\n";
			print '<data>',"\n";
			print '<value>',"\n";
			print '<struct>',"\n";
			print '<member><name>categoryId</name><value><string>',$ca,'</string></value></member>',"\n";
			print '<member><name>categoryName</name><value><string>',$category_name,'</string></value></member>',"\n";
			print '</struct>',"\n";
			print '</value>',"\n";
			print '</data>',"\n";
			print '</array>',"\n";
			print '</value>',"\n";
			print '</param>',"\n";
			print '</params>',"\n";
			print '</methodResponse>',"\n";
			last;
		}
	}
	close(IN);
	exit;
}

# -------------------------------------------------------------------------
#  JeS̕ҏW
# -------------------------------------------------------------------------

sub setPostCategories {
	if ($set_data1[9]) { &lock; }
	open(IN,"$set_data1[6]") || &xml_error("2","Failed to open a file.");
	$top = <IN>;
	while (<IN>) {
		($no,$exno,$reno,$category,$year,$mon,$mday,$wday,$time,$name,$title,$comment,$url,
			$mail,$host,$pw,$tail2,$w2,$h2,$ws2,$hs2,$skin,$album,$copy) = split(/<>/);
		if ($in{'num'} == $no) {
			$_ = "$no<><>$reno<>$in{'category'}<>$year<>$mon<>$mday<>$wday<>$time<>$name<>$title<>$comment<>$url<>$mail<>$host<>$set_data3[0]<>$tail<>$w<>$h<>$ws<>$hs<>$skin<>$album<>$copy<>\n";
		}
		push(@new,$_);
	}
	close(IN);
	unshift(@new,$top);
	open(OUT,">$set_data1[6]") || &xml_error("4","Failed to write a file.");
	print OUT @new;
	close(OUT);
	if ($set_data1[9]) { &unlock; }
	if (!$copy) {
		$rb_no = 5;
		&user_rebuild;
	}
	print 'Content-Type: text/xml;',"\n\n";
	print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
	print '<methodResponse>',"\n";
	print '<params>',"\n";
	print '<param>',"\n";
	print '<value><boolean>1</boolean></value>',"\n";
	print '</param>',"\n";
	print '</params>',"\n";
	print '</methodResponse>',"\n";
	exit;
}

# -------------------------------------------------------------------------
#  t@CAbv[h
# -------------------------------------------------------------------------

sub newMediaObject {
	if ($type =~ /image\/gif/i) { $flag=1; }
	if ($type =~ /image\/jpeg/i) { $flag=1; }
	if ($type =~ /image\/png/i) { $flag=1; }
	if (!$flag) {
		if ($fname =~ /\.gif$/i) { $flag=1; }
		if ($fname =~ /\.jpe?g$/i) { $flag=1; }
		if ($fname =~ /\.png$/i) { $flag=1; }
	}
	if (!$flag) {
		&xml_error("5","Failed to upload a file.");
	}
	$upfile = &mime_dec_base64( $bits );
	$fname =~ s/.*[:\/\\](.*)/$1/;
	$imgfile = "$set_data1[4]images/$fname";
	open(OUT,"> $imgfile") || &xml_error("5","Failed to upload a file.");
	binmode(OUT);
	binmode(STDOUT);
	print OUT $upfile;
	close(OUT);
	$imgsrc ="$set_data1[5]images/$fname";
	print 'Content-Type: text/xml;',"\n\n";
	print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
	print '<methodResponse>',"\n";
	print '<params>',"\n";
	print '<param>',"\n";
	print '<value>',"\n";
	print '<struct>',"\n";
	print '<member><name>url</name><value><string>',$imgsrc,'</string></value></member>',"\n";
	print '</struct>',"\n";
	print '</value>',"\n";
	print '</param>',"\n";
	print '</params>',"\n";
	print '</methodResponse>',"\n";
	exit;
}

# -------------------------------------------------------------------------
#  BASE64fR[h
# -------------------------------------------------------------------------

sub mime_dec_base64 {
	$_ = @_[0];
	tr!A-Za-z0-9+/!!cd;
	tr!A-Za-z0-9+/!\x00-\x3f!;
	$_ = unpack('B*', $_);
	s/(..)(......)/$2/g;
	s/((........)*)(.*)/$1/;
	$_ = pack('B*', $_);
	return( $_ );
}

# -------------------------------------------------------------------------
#  TCg̃rh
# -------------------------------------------------------------------------

sub user_rebuild {
	$e_all = 0;
	if ($set_data2[34] != 0) {
		local(@entry_year,@entry_mon,@entry_week);
		if ($set_data9[0] != 1) {
			$d_count = @set_data11 - 1;
			foreach $i (0 .. $d_count) {
				($entry_year[$i],$entry_mon[$i]) = split(/&/,$set_data11[$i]);
			}
		} else {
			$d_count = @set_data12 - 1;
			foreach $i (0 .. $d_count) {
				($entry_year[$i],$entry_mon[$i],$entry_week[$i]) = split(/&/,$set_data12[$i]);
			}
		}
		&calender_archive;
	}
	&pb_list;
	&html_archive;

	if ($set_data9[0] != 2){
		local(@entry_year,@entry_mon,@entry_week);
		if ($set_data9[0] != 1) {
			$a_all = @set_data11;
				foreach $i (0 .. $a_all-1) {
			($entry_year[$i],$entry_mon[$i]) = split(/&/,$set_data11[$i]);
			}
		} else {
			$a_all = @set_data12;
			foreach $i (0 .. $a_all-1) {
				($entry_year[$i],$entry_mon[$i],$entry_week[$i]) = split(/&/,$set_data12[$i]);
			}
		}
		$a_count = 0;
		if ($a_all > 0) {
			&month_archive;
		}
	}
	$e_count = 0;
	$rb_count = 0;
	local(@entry_year,@entry_mon);
	if ($set_data1[9]) { &lock; }
	open(IN,"$set_data1[6]") || &error("Open Error : $set_data1[6]");
	$top = <IN>;
	while (<IN>) {
		($no,$exno,$reno,$category,$year,$mon,$mday,$wday,$time,$name,$title,$comment,$url,
			$mail,$host,$pw,$tail,$w,$h,$ws,$hs,$skin,$album,$copy) = split(/<>/);
		if ($exno eq "" && !$copy) {
			push(@entry_no,$no);
			push(@entry_category,$category);
			push(@entry_year,$year);
			push(@entry_mon,$mon);
			push(@entry_mday,$mday);
			push(@entry_skin,$skin);
			$e_all++;
		}
	}
	close(IN);
	if ($set_data1[9]) { &unlock; }
	if ($e_all > 0) {
		&entry_archive;
	}
}

# -------------------------------------------------------------------------
#  XMLG[
# -------------------------------------------------------------------------

sub xml_error {
	&unlock if ($lockflag);
	print 'Content-Type: text/xml;',"\n\n";
	print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
	print '<methodResponse>',"\n";
	print '<fault>',"\n";
	print '<value>',"\n";
	print '<struct>',"\n";
	print '<member>',"\n";
	print '<name>faultCode</name>',"\n";
	print '<value><int>',$_[0],'</int></value>',"\n";
	print '</member>',"\n";
	print '<member>',"\n";
	print '<name>faultString</name>',"\n";
	print '<value><string>',$_[1],'</string></value>',"\n";
	print '</member>',"\n";
	print '</struct>',"\n";
	print '</value>',"\n";
	print '</fault>',"\n";
	print '</methodResponse>',"\n";
	exit;
}

# -------------------------------------------------------------------------
#  XMLԐM
# -------------------------------------------------------------------------

sub xml_reply {
	print 'Content-Type: text/xml;',"\n\n";
	print '<?xml version="1.0" encoding="UTF-8"?>',"\n";
	print '<methodResponse>',"\n";
	print '<params>',"\n";
	print '<param>',"\n";
	print '<value><string>',$_[0],'</string></value>',"\n";
	print '</param>',"\n";
	print '</params>',"\n";
	print '</methodResponse>',"\n";
	exit;
}

1;